unit RiffWalk;

interface

uses Windows, MMSystem;

function SearchChunk(var F: File; Id: PChar; var Size: Integer): Boolean;

implementation

function SearchChunk(var F: File; Id: PChar; var Size: Integer): Boolean;
var
  sid: FOURCC;
  buf: array[0..3] of Char;
begin
  Result := False;
  try
    while not Eof(F) do
    begin
      BlockRead(F, sid, SizeOf(sid));
      BlockRead(F, Size, SizeOf(Size));
      if (sid = mmioStringToFOURCC('RIFF', 0)) or (sid = mmioStringToFOURCC('LIST', 0)) then
      begin
        BlockRead(F, buf, SizeOf(buf));
        if sid = mmioStringToFOURCC(Id, 0) then
        begin
          Result := True;
          Exit;
        end;
      end
      else begin
        if Id = 'RIFF' then
          Exit;
        if Size mod 2 = 1 then Inc(Size);
        if sid = mmioStringToFOURCC(Id, 0) then
        begin
          Seek(F, FilePos(F)-8);
          Result := True;
          Exit;
        end else
          Seek(F, FilePos(F)+Size);
      end;
    end;
  except
  end;
end;

end.
